//
//  ISHomeViewController.m
//  ISIDReader
//
//  Created by Simon Liu on 17/3/9.
//  Copyright © 2017年 xzliu. All rights reserved.
//

#import "ISHomeViewController.h"
#import <ISDrivingLicensePreviewSDK/ISDrivingLicensePreviewSDK.h>
#import <ISOpenSDKFoundation/ISOpenSDKFoundation.h>
#import "ISViewController.h"
#import "ISDetailViewController.h"
#import "IntSigSDKStatus.h"

@implementation ISDrivingCardResultItem

-(id) init
{
    self = [super init];
    if (self) {
        _typeText = nil;
        _resultText = nil;
        _numberOfline = 1;
    }
    return self;
}

@end

@interface ISHomeViewController ()<ISOpenSDKCameraViewControllerDelegate>
{
    int _selectRecognType;
    int _recognInt;


}
@property (nonatomic, strong) ISOpenSDKCameraViewController *openSDKCameraVC;

@end

@implementation ISHomeViewController

- (void)viewWillAppear:(BOOL)animated
{
    self.navigationController.navigationBarHidden = YES;

}

- (void)viewDidLoad {
    [super viewDidLoad];
    
    
    self.learnMoreBtn.layer.borderWidth = 1.0f;
    self.learnMoreBtn.layer.borderColor = [UIColor colorWithRed:42.0f/255.0f green:125.0f/255.0f blue:243.0f/255.0f alpha:1].CGColor;
    
    self.cameraBtn.layer.cornerRadius = 30.0f;
    self.ablumBtn.layer.cornerRadius = 30.0f;
    self.recognitionBtn.layer.cornerRadius = 10.0f;

    
    self.learnMoreBtn.tag = 1001;
    self.cameraBtn.tag = 1002;
    self.ablumBtn.tag = 1003;
    self.recognitionBtn.tag = 1003;
    
    self.universalBtn.tag = 1004;
    self.singleBtn.tag = 1005;
    self.noFramewBtn.tag = 1006;
    
    self.navigationController.navigationBarHidden = YES;


    
    [self.learnMoreBtn addTarget:self action:@selector(clickButtonMethod:) forControlEvents:UIControlEventTouchUpInside];
    [self.cameraBtn addTarget:self action:@selector(clickButtonMethod:) forControlEvents:UIControlEventTouchUpInside];
    [self.ablumBtn addTarget:self action:@selector(clickButtonMethod:) forControlEvents:UIControlEventTouchUpInside];
    [self.recognitionBtn addTarget:self action:@selector(clickButtonMethod:) forControlEvents:UIControlEventTouchUpInside];

    [self.universalBtn addTarget:self action:@selector(clickButtonMethod:) forControlEvents:UIControlEventTouchUpInside];
    [self.singleBtn addTarget:self action:@selector(clickButtonMethod:) forControlEvents:UIControlEventTouchUpInside];
    [self.noFramewBtn addTarget:self action:@selector(clickButtonMethod:) forControlEvents:UIControlEventTouchUpInside];


}

- (void)clickButtonMethod:(UIButton *)sendBtn
{
    NSString *appkey = @"92f911e27b925954260a2c3ef0-vagfvt";
    NSString *subKey = nil;//reserved for future use

    switch (sendBtn.tag) {
        case 1001:
        {
            ISDetailViewController *detailVC = [[ISDetailViewController alloc] init];
            [self presentViewController:detailVC animated:YES completion:nil];
        }
            break;
            
        case 1003:
        {
            _openSDKCameraVC = [[ISDrivingLicensePreviewController sharedISOpenSDKController] cameraViewControllerWithAppkey:appkey subAppkey:subKey];
            _openSDKCameraVC.shouldHightlightCorners = YES;
            _openSDKCameraVC.customInfo = NSLocalizedString(@"请将驾驶证放在框内识别", @"请将驾驶证放在框内识别");
            _openSDKCameraVC.delegate = self;
            [self.navigationController pushViewController:_openSDKCameraVC animated:NO];
        }
            break;
        
    }

}

- (void)constructResourcesDidFinishedWithStatusCode:(ISOpenSDKStatus)status
{
    if (status != ISOpenSDKStatusSuccess)
    {
        NSLog(@"Init SDK failed with code:%ld", (long)status);
        NSString *msgStr = [IntSigSDKStatus statusAnalysis:status];
        NSString *messageString = [NSString stringWithFormat:@"[%ld]%@",(long)status,msgStr];
        UIAlertView *alertView = [[UIAlertView alloc] initWithTitle:@"Error" message:messageString delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil];
        [alertView show];
    }
}

- (void)cameraViewController:(UIViewController *)viewController didFinishRecognizeCard:(NSDictionary *)resultInfo cardSDKType:(ISOpenPreviewSDKType)sdkType
{
    if (resultInfo != nil)
    {
        [self showISOCRWithAttributes:resultInfo];
        ISViewController *resultVC = [[ISViewController alloc] initWithDictionary:resultInfo loadImageBool:YES];
        UINavigationController *navGCR = [[UINavigationController alloc] initWithRootViewController:resultVC];
        navGCR.modalTransitionStyle = UIModalTransitionStyleCoverVertical;
        [self presentViewController:navGCR animated:NO completion:nil];
        
    }
}

//如何将OCR识别结果进行解析
- (NSString *) showISOCRWithAttributes:(NSDictionary *) attributes
{
    NSMutableDictionary *mutableAttributes = [NSMutableDictionary dictionaryWithDictionary:attributes];
    NSMutableString *contentString = [NSMutableString stringWithCapacity:0];
    NSMutableString *string = [mutableAttributes objectForKey:kOpenSDKCardResultTypeCardName];
    if (string.length > 0)
    {
        [contentString appendFormat:@"%@\n", string];
        [mutableAttributes removeObjectForKey:kOpenSDKCardResultTypeCardName];
    }
    NSDictionary *itemInfo = [mutableAttributes objectForKey:kOpenSDKCardResultTypeCardItemInfo];
    {
        NSString *drivingCardID = [itemInfo valueForKey:kDrivingCardItemIDNumber];
        if (drivingCardID) {
            ISDrivingCardResultItem *item = [[ISDrivingCardResultItem alloc] init];
            item.typeText = NSLocalizedString(@"ID number:", @"DrivingCard number:");
            item.resultText = drivingCardID;
            [contentString appendFormat:@"%@: %@\n", item.typeText, item.resultText];
        }
    }
    
    {
        NSString *drivingCardName = [itemInfo valueForKey:kDrivingCardItemName];
        if (drivingCardName) {
            ISDrivingCardResultItem *item = [[ISDrivingCardResultItem alloc] init];
            item.typeText = NSLocalizedString(@"Name:", @"Name:");
            item.resultText = drivingCardName;
            [contentString appendFormat:@"%@: %@\n", item.typeText, item.resultText];
        }
    }
    
    {
        NSString *sex = [itemInfo valueForKey:kDrivingCardItemSex];
        if (sex) {
            ISDrivingCardResultItem *item = [[ISDrivingCardResultItem alloc] init];
            item.typeText = NSLocalizedString(@"Sex:", @"Sex:");
            item.resultText = sex;
            [contentString appendFormat:@"%@: %@\n", item.typeText, item.resultText];
        }
    }
    
    {
        NSString *nation = [itemInfo valueForKey:kDrivingCardItemNationality];
        if (nation) {
            ISDrivingCardResultItem *item = [[ISDrivingCardResultItem alloc] init];
            item.typeText = NSLocalizedString(@"Nation:", @"Nation:");
            item.resultText = nation;
            [contentString appendFormat:@"%@: %@\n", item.typeText, item.resultText];
        }
    }
    
    {
        NSString *address = [itemInfo valueForKey:kDrivingCardItemAddress];
        if (address) {
            ISDrivingCardResultItem *item = [[ISDrivingCardResultItem alloc] init];
            item.typeText = NSLocalizedString(@"Address:", @"Address:");
            item.resultText = address;
            item.numberOfline = 2;
            [contentString appendFormat:@"%@: %@\n", item.typeText, item.resultText];
        }
    }
    
    {
        NSString *birthDay = [itemInfo valueForKey:kDrivingCardItemBirthDay];
        if (birthDay) {
            ISDrivingCardResultItem *item = [[ISDrivingCardResultItem alloc] init];
            item.typeText = NSLocalizedString(@"BirthDay:", @"BirthDay:");
            item.resultText = birthDay;
            [contentString appendFormat:@"%@: %@\n", item.typeText, item.resultText];
        }
    }
    
    {
        NSString *issueDate = [itemInfo valueForKey:kDrivingCardItemIssueDate];
        if (issueDate) {
            ISDrivingCardResultItem *item = [[ISDrivingCardResultItem alloc] init];
            item.typeText = NSLocalizedString(@"IssueDate:", @"IssueDate:");
            item.resultText = issueDate;
            [contentString appendFormat:@"%@: %@\n", item.typeText, item.resultText];
        }
    }
    
    {
        NSString *driveType = [itemInfo valueForKey:kDrivingCardItemDriveType];
        if (driveType) {
            ISDrivingCardResultItem *item = [[ISDrivingCardResultItem alloc] init];
            item.typeText = NSLocalizedString(@"DriveType:", @"DriveType:");
            item.resultText = driveType;
            [contentString appendFormat:@"%@: %@\n", item.typeText, item.resultText];
        }
    }
    
    {
        NSString *drivingCardID = [itemInfo valueForKey:kDrivingCardItemValidFrom];
        if (drivingCardID) {
            ISDrivingCardResultItem *item = [[ISDrivingCardResultItem alloc] init];
            item.typeText = NSLocalizedString(@"ValidFrom:", @"ValidFrom:");
            item.resultText = drivingCardID;
            [contentString appendFormat:@"%@: %@\n", item.typeText, item.resultText];
        }
    }
    
    {
        NSString *drivingCardID = [itemInfo valueForKey:kDrivingCardItemValidFor];
        if (drivingCardID) {
            ISDrivingCardResultItem *item = [[ISDrivingCardResultItem alloc] init];
            item.typeText = NSLocalizedString(@"ExpireTime:", @"ExpireTime:");
            item.resultText = drivingCardID;
            [contentString appendFormat:@"%@: %@\n", item.typeText, item.resultText];
        }
    }
    
    {
        NSString *drivingCardID = [itemInfo valueForKey:kDrivingCardItemValidity];
        if (drivingCardID) {
            ISDrivingCardResultItem *item = [[ISDrivingCardResultItem alloc] init];
            item.typeText = NSLocalizedString(@"ValidFor:", @"ValidFor:");
            item.resultText = drivingCardID;
            [contentString appendFormat:@"%@: %@\n", item.typeText, item.resultText];
        }
    }
    
    NSLog(@"OCR Result=\n%@",contentString);
    return contentString;
    
}


- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

@end
