//
//  AppDelegate.m
//  ISDrivingLicensePreviewDemo
//
//  Created by Simon liu on 17/2/7.
//  Copyright (c) 2017年 xzliu. All rights reserved.
//

#import "AppDelegate.h"
#import "ISLaunchAnimateViewController.h"

@interface AppDelegate ()

@end

@implementation AppDelegate


- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {
    // Override point for customization after application launch.
    [self.window makeKeyAndVisible];
    [self setUpLaunchImageAnimate];
    return YES;
}

- (void)setUpLaunchImageAnimate
{
    // init launch view
    UIView *launchView = [[UIView alloc]initWithFrame:[UIScreen mainScreen].bounds];
    launchView.backgroundColor = [UIColor whiteColor];
    UIImageView *imageView = [[UIImageView alloc]initWithFrame:launchView.frame];
    imageView.image = [UIImage imageNamed:@"IS_OCR_Launch"];
    imageView.center = launchView.center;
    [launchView addSubview:imageView];
    
    UILabel *versionLab = [[UILabel alloc] init];
    versionLab.backgroundColor = [UIColor blackColor];
    versionLab.layer.masksToBounds = YES;
    versionLab.layer.cornerRadius = 15;
    versionLab.layer.borderWidth=1.0f;
    versionLab.text = @"驾驶证识别v1.6";
    versionLab.textColor = [UIColor whiteColor];
    versionLab.font = [UIFont systemFontOfSize:15.0f];
    versionLab.textAlignment = NSTextAlignmentCenter;
    CGFloat y_f = imageView.frame.size.height*4/5;
    versionLab.frame = CGRectMake((imageView.frame.size.width-200)/2, y_f, 200, 30);
    [imageView addSubview:versionLab];
    
    ISLaunchAnimateViewController *launchCtrl = [[ISLaunchAnimateViewController alloc]initWithContentView:launchView animateType:ISLaunchAnimateTypePointZoomOut2 showSkipButton:YES];
    [launchCtrl show];
}

- (void)applicationWillResignActive:(UIApplication *)application {
    // Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
    // Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
}

- (void)applicationDidEnterBackground:(UIApplication *)application {
    // Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later.
    // If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.
}

- (void)applicationWillEnterForeground:(UIApplication *)application {
    // Called as part of the transition from the background to the inactive state; here you can undo many of the changes made on entering the background.
}

- (void)applicationDidBecomeActive:(UIApplication *)application {
    // Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
}

- (void)applicationWillTerminate:(UIApplication *)application {
    // Called when the application is about to terminate. Save data if appropriate. See also applicationDidEnterBackground:.
}

@end
