//
//  ISResultViewController.m
//  ISIDReaderCameraPreviewDemo
//
//  Created by Simon Liu on 17/3/9.
//  Copyright © 2017年 xzliu. All rights reserved.
//

#import "ISResultViewController.h"
#import <ISDrivingLicensePreviewSDK/ISDrivingLicensePreviewSDK.h>
#import <ISOpenSDKFoundation/ISOpenSDKFoundation.h>
#import "Masonry.h"
#import "ISZoomScrollView.h"
#define IS_DEVICE_HEIGHT    [[UIScreen mainScreen] bounds].size.height
#define IS_DEVICE_WIDTH     [[UIScreen mainScreen] bounds].size.width

@interface ISResultViewController ()<UIGestureRecognizerDelegate,UITextFieldDelegate>
{
    UIScrollView *_resultScrollView;
    UIView *_bannerView;
    UIView *_resultInfoView;
    NSArray *_infoArray;
    
    CGFloat _widthFloat;
    CGFloat _tempHeight;
    CGFloat _titleLab_Height;
    CGFloat _titleLab_Y;
    CGFloat _titleLab_Old_Height;
    CGFloat _titleLab_Old_Y;
    
    NSDictionary *_idCardDict;
    NSArray *_idCardArray;
    NSArray *_idCardBackArray;
    NSArray *_infoImageArray;
    
    CGFloat _oldScrollViewheight;
    CGFloat _oldheight;

    BOOL _loadImageBOOL;
}


@property (weak, nonatomic) IBOutlet UILabel *titleLabel;
@property (strong, nonatomic) NSDictionary *infoDic;
@property (strong, nonatomic) UIImage *originImage;
@property (strong, nonatomic) UIImage *headImage;
@property (strong, nonatomic) UIImage *typeImage;

@end

@implementation ISResultViewController

- (instancetype)initWithDictionary:(NSDictionary *)info loadImageBool:(BOOL)loadImageBOOL
{
    self = [super init];
    if (self != nil) {
        self.originImage = [info valueForKey:kOpenSDKCardResultTypeImage];
        self.infoDic = [info valueForKey:kOpenSDKCardResultTypeCardItemInfo];
        _loadImageBOOL=loadImageBOOL;
        self.typeImage = [info valueForKey:kOpenSDKCardResultTypeOriginImage];
//        self.originImageView.contentMode = UIViewContentModeScaleAspectFit;
//        self.originImageView.image = self.originImage;
    }
    return self;
}

- (void)viewDidLoad {
    [super viewDidLoad];
    self.navigationItem.title = @"驾驶证识别结果";
/*
 extern NSString *const kDrivingCardItemIDNumber;//驾驶证号
 extern NSString *const kDrivingCardItemName;//姓名
 extern NSString *const kDrivingCardItemSex;//性别
 extern NSString *const kDrivingCardItemNationality;//国籍
 extern NSString *const kDrivingCardItemAddress;//地址
 extern NSString *const kDrivingCardItemBirthDay;//出生日期
 extern NSString *const kDrivingCardItemIssueDate;//初次申领日期
 extern NSString *const kDrivingCardItemDriveType;//准驾车型
 extern NSString *const kDrivingCardItemValidFrom;//有效起始日期
 extern NSString *const kDrivingCardItemValidFor;//截止日期
 extern NSString *const kDrivingCardItemValidity;//有效期限
 */

    _idCardDict = @{
                    kDrivingCardItemIDNumber:@"驾驶证号",
                    kDrivingCardItemName:@"姓名",
                    kDrivingCardItemSex:@"性别",
                    kDrivingCardItemNationality:@"国籍",
                    kDrivingCardItemAddress:@"地址",
                    kDrivingCardItemBirthDay:@"出生日期",
                    kDrivingCardItemIssueDate:@"初次申领日期",
                    kDrivingCardItemDriveType:@"准驾车型",
                    kDrivingCardItemValidFrom:@"有效起始日期",
                    kDrivingCardItemValidFor:@"截止日期",
                    kDrivingCardItemValidity:@"有效期限"
                    };
    _idCardArray = @[
                     kDrivingCardItemIDNumber,
                     kDrivingCardItemName,
                     kDrivingCardItemSex,
                     kDrivingCardItemNationality,
                     kDrivingCardItemAddress,
                     kDrivingCardItemBirthDay,
                     kDrivingCardItemIssueDate,
                     kDrivingCardItemDriveType,
                     kDrivingCardItemValidFrom,
                     kDrivingCardItemValidFor,
                     kDrivingCardItemValidity
                     ];

    _oldScrollViewheight = IS_DEVICE_HEIGHT +180;
    if (_loadImageBOOL==NO) {
        _infoImageArray = [[NSArray alloc] init];
    }else{
        _infoImageArray = @[self.originImage,self.typeImage];

    }
    
    [self configResultScrollView];
}
- (void)configResultScrollView
{
    _resultScrollView = [[UIScrollView alloc] init];
    _resultScrollView.backgroundColor = [UIColor colorWithRed:240.0f/255.0f green:239.0f/255.0f blue:245.0f/255.0f alpha:1];
    _resultScrollView.contentSize = CGSizeMake(IS_DEVICE_WIDTH, IS_DEVICE_HEIGHT);
    [self.view addSubview:_resultScrollView];
    [_resultScrollView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.size.mas_equalTo(CGSizeMake(IS_DEVICE_WIDTH, IS_DEVICE_HEIGHT));
        
    }];
    
    UITapGestureRecognizer *sigleTapRecognizer = [[UITapGestureRecognizer alloc]initWithTarget:self action:@selector(clickBackView)];
    sigleTapRecognizer.delegate=self;
    sigleTapRecognizer.numberOfTapsRequired = 1;
    
    [_resultScrollView addGestureRecognizer:sigleTapRecognizer];
    
    [self configBannerView];
}

//键盘遮挡事件
- (void)textFieldDidBeginEditing:(UITextField *)textField

{
    _resultScrollView.contentSize = CGSizeMake(IS_DEVICE_WIDTH,IS_DEVICE_HEIGHT +216);//原始滑动距离增加键盘高度
    CGPoint pt = [textField convertPoint:CGPointMake(0, 0) toView:_resultScrollView];//把当前的textField的坐标映射到scrollview上
    if(_resultScrollView.contentOffset.y-pt.y+64<=0)//判断最上面不要去滚动
        [_resultScrollView setContentOffset:CGPointMake(0, pt.y-64) animated:YES];//华东
}

- (void)clickBackView
{
    
    [self.view endEditing:YES];
    
    //开始动画
    [UIView beginAnimations:nil context:nil];
    //设定动画持续时间
    [UIView setAnimationDuration:0.3];
    _resultScrollView.frame = CGRectMake(0, 0, IS_DEVICE_WIDTH, IS_DEVICE_HEIGHT);
    _resultScrollView.contentSize = CGSizeMake(IS_DEVICE_WIDTH, IS_DEVICE_HEIGHT*2/7+_titleLab_Y+130);
    //动画结束
    [UIView commitAnimations];
}

- (void)configBannerView
{
    _bannerView = [[UIScrollView alloc] init];
    _bannerView.backgroundColor = [UIColor blueColor];
    [_resultScrollView addSubview:_bannerView];
    
    if (_loadImageBOOL==NO) {
        [_bannerView mas_makeConstraints:^(MASConstraintMaker *make) {
            make.size.mas_equalTo(CGSizeMake(IS_DEVICE_WIDTH, 0));
            make.top.equalTo(_resultScrollView.mas_top).offset(0);
        }];
    }else{
        [_bannerView mas_makeConstraints:^(MASConstraintMaker *make) {
            make.size.mas_equalTo(CGSizeMake(IS_DEVICE_WIDTH, IS_DEVICE_HEIGHT*2/7));
            make.top.equalTo(_resultScrollView.mas_top).offset(0);
        }];
        ISZoomScrollView *zoomScrollView = [ISZoomScrollView roundScrollViewWithFrame:CGRectMake(0, 0, IS_DEVICE_WIDTH, IS_DEVICE_HEIGHT*2/7) imageArr:_infoImageArray timerWithTimeInterval:5 imageClick:^(NSInteger imageIndex) {
        }];
        [_bannerView addSubview:zoomScrollView];
    }
    
    
    [self configResultInfoView];
}

- (void)configResultInfoView
{
    _resultInfoView = [[UIView alloc] init];
    _resultInfoView.backgroundColor = [UIColor whiteColor];
    [_resultScrollView addSubview:_resultInfoView];
    [self configDisplayView];
    
}

- (void)configDisplayView
{
    _titleLab_Old_Y = 0.0f;
    _titleLab_Old_Height = 0.0f;
    _titleLab_Y = 0.0f;
    _titleLab_Height = 0.0f;
    _widthFloat = 100.0f;
    _tempHeight = 13.0f;
    CGFloat keepLeft = 15.0f;
    UIFont *fontSize = [UIFont systemFontOfSize:14];
    NSDictionary *attribute = @{NSFontAttributeName: fontSize};
    

    NSLog(@"infoDict=%@",self.infoDic);
    for(int i = 0 ; i < self.infoDic.count ; i ++)
    {
        NSString *dpInfoKey = @"";
        if (self.infoDic.count==2) {
            dpInfoKey = _idCardBackArray[i];
        }else{
            dpInfoKey = _idCardArray[i];

        }

        NSString *infoKey = _idCardDict[dpInfoKey];
        NSString *infoValue =[self.infoDic objectForKey:dpInfoKey];

        if (infoValue.length==0) {
            
        }else{
            UILabel *titleLab = [[UILabel alloc] init];
            titleLab.backgroundColor = [UIColor clearColor];
            titleLab.numberOfLines = 0 ;
            titleLab.textColor = [UIColor colorWithRed:149.0f/255.0f green:149.0f/255.0f blue:149.0f/255.0f alpha:1];
            titleLab.font = fontSize;
            titleLab.text =infoKey;
            CGSize titleAreaSize = [self configDrawAndSizeMultiLineText:infoKey boundingRectWithSize:CGSizeMake(_widthFloat, MAXFLOAT) attributes:attribute];
            
            UITextField *infoTF = [[UITextField alloc] init];
            infoTF.delegate=self;
            infoTF.backgroundColor = [UIColor clearColor];
            infoTF.font = fontSize;
            infoTF.text = infoValue;
            CGFloat infoTF_Width = IS_DEVICE_WIDTH - _widthFloat - keepLeft*2 +10;
            //        CGSize infoTFAreaSize = [self configDrawAndSizeMultiLineText:infoValue boundingRectWithSize:CGSizeMake(infoTF_Width, MAXFLOAT) attributes:attribute];
            
            _titleLab_Height = titleAreaSize.height;
            _titleLab_Y = 11 + _titleLab_Old_Y + _titleLab_Old_Height;
            
            [titleLab setFrame:CGRectMake(keepLeft, _titleLab_Y, _widthFloat, titleAreaSize.height+_tempHeight)];
            [infoTF setFrame:CGRectMake(titleLab.frame.size.width+keepLeft+10, _titleLab_Y, infoTF_Width - 20, titleAreaSize.height+_tempHeight)];
            
            _titleLab_Old_Height = titleLab.frame.size.height;
            _titleLab_Old_Y = titleLab.frame.origin.y;
            
            
            
            if (i==self.infoDic.count-1) {
                UIImageView *headImageView = [[UIImageView alloc] init];
                headImageView.image = self.headImage;
                headImageView.backgroundColor = [UIColor clearColor];
                CGFloat wh_float = (titleAreaSize.height+_tempHeight)*3;
                
                headImageView.frame = CGRectMake(IS_DEVICE_WIDTH-wh_float-keepLeft, keepLeft, wh_float, wh_float+5);
                [_resultInfoView addSubview:headImageView];
            }else{
                UIView *lineView = [[UIView alloc] init];
                lineView.frame = CGRectMake(0, _titleLab_Y+titleLab.frame.size.height+5, IS_DEVICE_WIDTH, 1);
                lineView.backgroundColor =[UIColor colorWithRed:240.0f/255.0f green:239.0f/255.0f blue:245.0f/255.0f alpha:1];
                [_resultInfoView addSubview:lineView];
            }
            
            if (self.headImage == nil) {
                
            }
            
            
            [_resultInfoView addSubview:titleLab];
            [_resultInfoView addSubview:infoTF];

        }
        
    }
    [_resultInfoView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.size.mas_equalTo(CGSizeMake(IS_DEVICE_WIDTH, _titleLab_Old_Y + _titleLab_Old_Height+10));
        make.top.equalTo(_bannerView.mas_bottom).offset(15);
    }];
    _resultScrollView.contentSize = CGSizeMake(IS_DEVICE_WIDTH, IS_DEVICE_HEIGHT*2/7+_titleLab_Y+130);

    [self configButtonView];
    
}
- (CGSize )configDrawAndSizeMultiLineText:(NSString *)formatString boundingRectWithSize:(CGSize)size attributes:(NSDictionary *)attribute
{
    CGSize returnSize={0, 0};
    returnSize = [formatString boundingRectWithSize:size options: NSStringDrawingTruncatesLastVisibleLine | NSStringDrawingUsesLineFragmentOrigin | NSStringDrawingUsesFontLeading attributes:attribute context:nil].size;
    return returnSize;
}

- (void)configButtonView
{
    UIButton *okBtn = [[UIButton alloc] init];
    okBtn.backgroundColor = [UIColor colorWithRed:20.0f/255.0f green:182.0f/255.0f blue:242.0f/255.0f alpha:1];
    [okBtn setTitle:@"确  定" forState:UIControlStateNormal];
    [okBtn setTitleColor:[UIColor colorWithRed:255.0f/255.0f green:255.0f/255.0f blue:255.0f/255.0f alpha:1] forState:UIControlStateNormal];
    [okBtn addTarget:self action:@selector(clickOKButtonMethod) forControlEvents:UIControlEventTouchUpInside];
    [_resultScrollView addSubview:okBtn];
    [okBtn mas_makeConstraints:^(MASConstraintMaker *make) {

        make.left.equalTo(_resultInfoView.mas_left).offset(25);
        make.size.mas_equalTo(CGSizeMake(IS_DEVICE_WIDTH - 50, 40));
        make.top.equalTo(_resultInfoView.mas_bottom).offset(15);
    }];
}

- (void)clickOKButtonMethod
{
    NSLog(@"click ok");
    [self dismissViewControllerAnimated:YES completion:^{
        
    }];
}



- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}


@end



