//
//  ISZoomScrollView.h
//  ISIDReaderCameraPreviewDemo
//
//  Created by Simon Liu on 17/3/6.
//  Copyright © 2017年 xzliu. All rights reserved.
//

#import <UIKit/UIKit.h>


typedef void(^imageClick)(NSInteger imageIndex);

typedef enum : NSUInteger {
    NSPageControlAlignmentCenter,//中间位置
    NSPageControlAlignmentRight,//右边位置
} NSPageControlAlignment;


@interface ISZoomScrollView : UIView

/**
 *  小圆点控制器的位置
 */
@property(nonatomic)NSPageControlAlignment pageControlAlignment;
/**
 *  当前小圆点颜色
 */
@property(nonatomic,retain)UIColor *curPageControlColor;
/**
 *  其余小圆点颜色
 */
@property(nonatomic,retain)UIColor *otherPageControlColor;

@property(nonatomic,assign)NSInteger scrlloTag;

/**
 *
 *  @param frame        frame
 *  @param imageArr     图片数组，网络图片或者本地图片
 *  @param timeInterVal 定时器间隔时间
 *  @param imgClick     图片点击事件
 *
 *  @return SZKRoundScrollView加定时器无限滚动视图
 */
+(instancetype)roundScrollViewWithFrame:(CGRect)frame
                               imageArr:(NSArray *)imageArr
                  timerWithTimeInterval:(NSTimeInterval)timeInterVal
                             imageClick:(imageClick)imgClick;
/**
 *  暂停定时器
 */
-(void)pasueTimer;
/**
 *  开启定时器
 */
-(void)startTimer;
@end
